SystemOrganization addCategory: #DiceRoller!
SystemOrganization addCategory: #'DiceRoller-Test'!

TestCase subclass: #DiceEvaluationTest
	instanceVariableNames: 'expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller-Test'!

!DiceEvaluationTest commentStamp: 'hjo 8/6/2012 11:17' prior: 0!
"http://www.rubyquiz.com/quiz61.html"!

DiceEvaluationTest subclass: #DRT3d3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller-Test'!

!DRT3d3 commentStamp: 'hjo 8/6/2012 14:27' prior: 0!
3d6!

!DRT3d3 methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 11:16'!
setUp

	super setUp.
	expression := DERollsDSides new 
	rolls: (DEInteger new positiveInteger: 3);
	sideOfDice: (DEInteger new positiveInteger: 3).! !

!DRT3d3 methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 11:19'!
test6times

	(6 timesCollect: [expression value]) do: [:each| self assert: (each between: 3 and: 18) ].! !

DiceEvaluationTest subclass: #DRT5d5m4d16dd4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller-Test'!

!DRT5d5m4d16dd4 commentStamp: 'hjo 8/6/2012 14:27' prior: 0!
(5d5-4)d(16/d4)+3!

!DRT5d5m4d16dd4 methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 14:31'!
setUp

	| int t1 t2 t3 t4 t5 |
	super setUp.
	int := [:x| DEInteger new positiveInteger: x  ]. 

	"5d5"
	t1 := DERollsDSides new 
		rolls: (int value: 5);
		sideOfDice: (int value: 5).

	"5d5-4"
	t2 := DESubtract new 
		left: t1;
		right: (int value: 4).

	"d4"
	t3 := DERollsDSides new
		sideOfDice: (int value: 4).

	"16/d4"
	t4 := DEDivision new
		left: (int value: 16);
		right: t3.

	"(5d5-4)d(16/d4)"
	t5 := DEDivision new
		left: t2;
		right: t4.

	"(5d5-4)d(16/d4)+3"
	expression := DEAdd new
		left: t5;
		right: (int value: 3).! !

!DRT5d5m4d16dd4 methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 14:33'!
test6times

	(6 timesCollect: [expression value]) do: [:each| self assert: (each between: (49/16) and:  87) ].! !

TestCase subclass: #DiceParsingTest
	instanceVariableNames: 'expression parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller-Test'!

!DiceParsingTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 14:45'!
setUp

	super setUp.
	parser := DiceParcer new.! !

!DiceParsingTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 14:44'!
test1

	expression := parser parseString: '1'.
	self assert: (DEInteger new positiveInteger: 1) equals: (expression).! !

!DiceParsingTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 14:50'!
test2

	expression := parser parseString: '2'.
	self assert: (DEInteger new positiveInteger: 2) equals: (expression).! !

!DiceParsingTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 14:54'!
test3d6

	expression := parser parseString: '3d6'.
	self assert: (DERollsDSides new rolls: (DEInteger new positiveInteger: 3); sideOfDice: (DEInteger new positiveInteger: 6)) equals: (expression).! !

!DiceParsingTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 16:03'!
testConst

	expression := parser parseString: 'd'.
	self assert: (DEConstant new string: 'd') equals: (expression).! !

!DiceParsingTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 23:49'!
testParenthesis

	expression := parser parseString: '(7)'.
	self assert: (DEParenthesized new insideExpression: (DEInteger new positiveInteger: 7)) equals: (expression).! !

Object subclass: #Dice
	instanceVariableNames: 'diceExpression rolls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

!Dice methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:20'!
roll! !

Object subclass: #DiceExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

DiceExpression subclass: #DEBinaryOperation
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

DEBinaryOperation subclass: #DEAdd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

!DEAdd methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:26'!
precedence

	^10! !

!DEAdd methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:43'!
value

	^left value + right value! !

!DEBinaryOperation methodsFor: 'accessing' stamp: 'hjo 8/1/2012 12:36'!
left
	^ left! !

!DEBinaryOperation methodsFor: 'accessing' stamp: 'hjo 8/1/2012 12:36'!
left: aDiceExpression
	left := aDiceExpression! !

!DEBinaryOperation methodsFor: 'accessing' stamp: 'hjo 8/1/2012 12:36'!
right
	^ right! !

!DEBinaryOperation methodsFor: 'accessing' stamp: 'hjo 8/1/2012 12:36'!
right: aDiceExpression
	right := aDiceExpression! !

DEBinaryOperation subclass: #DEDivision
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

!DEDivision methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:26'!
precedence

	^50! !

!DEDivision methodsFor: 'as yet unclassified' stamp: 'hjo 8/2/2012 10:07'!
value

	^(left value / right value) asFloat! !

DEBinaryOperation subclass: #DEMultiply
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

!DEMultiply methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:26'!
precedence

	^50! !

!DEMultiply methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:44'!
value

	^left value * right value! !

DEBinaryOperation subclass: #DESubtract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

!DESubtract methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:26'!
precedence

	^10! !

!DESubtract methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:44'!
value

	^left value - right value! !

DiceExpression subclass: #DEConstant
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

!DEConstant methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 16:07'!
= aDiceExpression

	self == aDiceExpression ifTrue: [^true].
	(aDiceExpression respondsTo: #string) ifFalse: [^false].
	^(self string) = (aDiceExpression string)! !

!DEConstant methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 16:06'!
hash

	^string hash! !

!DEConstant methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 16:08'!
string

	^string ! !

!DEConstant methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 16:06'!
string: aByteString 

	string := aByteString.! !

DiceExpression subclass: #DEInteger
	instanceVariableNames: 'positiveInteger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

!DEInteger classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 15:07'!
readFrom: textStringOrStream

	| instance stream num |
	instance := self new.
	stream := textStringOrStream readStream.
	num := 0.
	[ |char|
	stream atEnd ifTrue: [^instance].
	char := stream next.
	char isDigit ifFalse: [stream skip: -1. ^instance].
	num := num * 10 + char digitValue.
	instance positiveInteger: num.
	] repeat.
	^instance.! !

!DEInteger methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 14:50'!
= aDEInteger

	self == aDEInteger ifTrue: [^true].
	^(aDEInteger respondsTo: #positiveInteger) and: [ self positiveInteger = aDEInteger positiveInteger].! !

!DEInteger methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 14:47'!
hash

	^positiveInteger hash! !

!DEInteger methodsFor: 'accessing' stamp: 'hjo 8/6/2012 14:46'!
positiveInteger

	^positiveInteger! !

!DEInteger methodsFor: 'accessing' stamp: 'hjo 8/1/2012 12:40'!
positiveInteger: anInteger
	self assert: [anInteger isInteger].
	self assert: [anInteger > 0].
	positiveInteger := anInteger
! !

!DEInteger methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:39'!
value

	^positiveInteger! !

DiceExpression subclass: #DEParenthesized
	instanceVariableNames: 'insideExpression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

!DEParenthesized methodsFor: 'as yet unclassified' stamp: 'hjo 8/7/2012 17:43'!
= aDiceExpression

	self == aDiceExpression ifTrue: [ ^true ].
	(aDiceExpression respondsTo: #insideExpression) ifFalse: [^false].
	^self insideExpression  = aDiceExpression insideExpression! !

!DEParenthesized methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 23:51'!
hash

	^insideExpression hash + 1! !

!DEParenthesized methodsFor: 'accessing' stamp: 'hjo 8/6/2012 23:48'!
insideExpression
	^ insideExpression! !

!DEParenthesized methodsFor: 'accessing' stamp: 'hjo 8/6/2012 23:48'!
insideExpression: anObject
	insideExpression := anObject! !

!DEParenthesized methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:25'!
precedence

	^100! !

!DEParenthesized methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:41'!
value

	^insideExpression value.! !

DiceExpression subclass: #DERollsDSides
	instanceVariableNames: 'rolls sideOfDice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

!DERollsDSides commentStamp: 'hjo 8/1/2012 12:23' prior: 0!
XdY rolls a Y-sided die (numbered
  from 1 to Y) X times, accumulating the results.  X is optional
  and defaults to 1.!

!DERollsDSides methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 14:59'!
= aDiceExpression

	self == aDiceExpression ifTrue: [^true].
	(aDiceExpression respondsTo: #rolls) ifFalse: [^false].
	(aDiceExpression respondsTo: #sideOfDice) ifFalse: [^false].
	aDiceExpression rolls = self rolls ifFalse: [^false].
	aDiceExpression sideOfDice = self sideOfDice ifFalse: [^false].
	^true.! !

!DERollsDSides methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 14:56'!
hash

	rolls hash xor: [sideOfDice hash * 7]! !

!DERollsDSides methodsFor: 'as yet unclassified' stamp: 'hjo 8/2/2012 10:07'!
initialize

	super initialize.
	rolls := DEInteger new positiveInteger: 1.! !

!DERollsDSides methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:25'!
precedence

	^90! !

!DERollsDSides methodsFor: 'accessing' stamp: 'hjo 8/1/2012 12:45'!
rolls
	^ rolls! !

!DERollsDSides methodsFor: 'accessing' stamp: 'hjo 8/6/2012 14:34'!
rolls: aDiceExpression

	rolls := aDiceExpression asDiceExpression
! !

!DERollsDSides methodsFor: 'accessing' stamp: 'hjo 8/1/2012 12:45'!
sideOfDice
	^ sideOfDice! !

!DERollsDSides methodsFor: 'accessing' stamp: 'hjo 8/1/2012 12:45'!
sideOfDice: aDiceExpression
	sideOfDice := aDiceExpression
! !

!DERollsDSides methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:46'!
value

	^((1 to: rolls value) collect: [:each| sideOfDice value atRandom]) sum! !

!DiceExpression classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:31'!
precedenceDictionary

	| dic |
	dic := Dictionary new.
	self allSubclassesDo: [:each| (each canUnderstand: #precedence) ifTrue: [dic at: each put: each new precedence] ifFalse: [dic at: each put: #noPrecedence] ].
	^dic! !

!DiceExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 14:34'!
asDiceExpression

	^self! !

!DiceExpression methodsFor: 'as yet unclassified' stamp: 'hjo 8/1/2012 12:38'!
value

	^self subclassResponsibility.! !

Object subclass: #DiceParcer
	instanceVariableNames: 'expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceRoller'!

!DiceParcer methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 16:05'!
parseStream: aReadStream

	| char |
	char := aReadStream peek.
	
	char = $d ifTrue: [aReadStream next. expression := DEConstant new string: 'd'. ^expression].
	
	(char = $2 or: [char = $1]) ifTrue: [expression := DEInteger readFrom: aReadStream. aReadStream atEnd ifTrue: [^expression] ].
	char = $3 ifTrue: 
		[|inChar|
		expression := (DEInteger readFrom: aReadStream).
		inChar := aReadStream peek.
		inChar = $d ifTrue: 
			[expression := DERollsDSides new rolls: expression.
			aReadStream next.
			expression sideOfDice: (DEInteger readFrom: aReadStream). ^expression.
			] ].
	char = $( ifTrue: [ aReadStream next. aReadStream skipSeparators.  expression := DEParenthesized new insideExpression: (DEInteger readFrom: aReadStream). ^expression  ].
	self shouldBeImplemented.! !

!DiceParcer methodsFor: 'as yet unclassified' stamp: 'hjo 8/6/2012 23:44'!
parseString: aByteString 

	^self parseStream: aByteString readStream.
! !
